//******************************************************************************
//* 					             Rec_Cmd.C
//* The function is reading the RS-232 command from the Hyper Terminal (VT100)
//* 
//*     Press "1" for setting the Maximum Temperature with 2 digital
//*   	Press "2" for setting the Minimum Temperature with 2 digital
//*   	Press "3" to start the auto cooling system
//*   	Press "4" to shutdown the cooling system
//*
//******************************************************************************

#include "Main.h"

extern near unsigned char Rec_Data;
extern near unsigned char Buzzer_Count;
extern near union
{
	unsigned char Flag;	
	struct {
			unsigned Key_Flag:1;
    		unsigned Timer1_Flag:1;
    		unsigned Pause_Flag:1;
			unsigned Buzzer_On_Flag:1;
			unsigned Buzzer_Fast_Flag:1;
			unsigned Buzzer_Mid_Flag:1;
			unsigned Buzzer_Slow_Flag:1;
			unsigned Shutdown_Flag:1;
    		};		
} Flagbits;

// #pragma udata access Near_Data
int T2_Max_Data;
int T2_Min_Data;
int T2_Setting;
unsigned char T2_Hi;
unsigned char T2_Mid;
unsigned char T2_Low;



#pragma udata
union
{
int Word;
unsigned char Byte[2];
}T2;

void Rec_Cmd_Check(void)
{
	if (Rec_Data!=0x00)
	{
		switch(Rec_Data)
		{
			case ('1'):
			{
				Modify_T2_Max( );
			} break;
			
			case ('2'):
			{
				Modify_T2_Min( );
			} break;
			
			case ('3'):
			{
				Cooling_Auto( );
			} break;
			
			case ('4'):
			{
				Cooling_Shutdown( );
			} break;
				

		}
		Rec_Data=0;
				
	}		
 
}

void Cooling_Auto(void) 
{
	Flagbits.Shutdown_Flag=0;
	TRISBbits.TRISB3=0; 				// Turn on the PWM2 output	(FAN)
}

void Cooling_Shutdown(void)
{
	Flagbits.Shutdown_Flag=1;
	TRISBbits.TRISB3=1; 				// Turn off the PWM2 output	(FAN)
	Buzzer_Count=0;	    				// Buzzer On 20 Sec with Fast mode
	Flagbits.Buzzer_Fast_Flag=0;
	Flagbits.Buzzer_Mid_Flag=0;
	Flagbits.Buzzer_Slow_Flag==0;

}
void Modify_T2_Max(void)
{	
	Rec_Data=0;
	VT100_Cursor_Position(20,34);
	Print_Byte(' ');
	Print_Byte(' ');
	Print_Byte(' ');
	Print_Byte(' ');
	Print_Byte(' ');
	VT100_Cursor_Position(20,34);
	T2_Max_Data = Get_3_Digital( ); 
	
	T2.Word=T2_Max_Data;
	EE_Write(0x00,T2.Byte[0]);
	EE_Write(0x01,T2.Byte[1]);

}

int Get_3_Digital(void)
{		
	do
	{		
		while(Rec_Data==0x00);	// Wait for data to be received
    	T2_Hi = Rec_Data;
    	Rec_Data=0x00;

    } while (T2_Hi < '0' || T2_Hi > '9');
    WriteUSART(T2_Hi);

 	do
	{		
		while(Rec_Data==0x00);	// Wait for data to be received
    	T2_Mid  = Rec_Data;
    	Rec_Data=0x00;
    	
    } while (T2_Mid < '0' || T2_Mid > '9');	
    WriteUSART(T2_Mid);
	while (BusyUSART( ));
    WriteUSART('.');
		   	
   	do
	{		
		while(Rec_Data==0x00);	// Wait for data to be received
    	T2_Low = Rec_Data;
    	Rec_Data=0x00;
    	
    } while (T2_Low < '0' || T2_Low > '9');
    WriteUSART(T2_Low);


	T2_Setting = (int) (T2_Hi & 0x0F);
	T2_Setting = T2_Setting * 100;
	T2_Mid = (T2_Mid & 0x0F) * 0x0A;
	T2_Low = (T2_Low & 0x0F);
    T2_Setting = T2_Setting+ (int) T2_Mid;
	T2_Setting = T2_Setting+ (int) T2_Low;

	Print_Byte('C');
	return	T2_Setting;
}

void Modify_T2_Min(void) 
{
	Rec_Data=0;
	VT100_Cursor_Position(21,34);
	Print_Byte(' ');
	Print_Byte(' ');
	Print_Byte(' ');
	Print_Byte(' ');
	Print_Byte(' ');
	VT100_Cursor_Position(21,34);
	T2_Min_Data = Get_3_Digital( ); 
	T2.Word=T2_Min_Data;
	EE_Write(0x02,T2.Byte[0]);
	EE_Write(0x03,T2.Byte[1]);
}


